#include <math.h>

double getRodConBasicEnergy (
  double bKh,
  double bKw,
  double tK,
  double L0,
  double *iniMatTanRB,
  double *iniMatNorRB,
  double *iniRefTanRO,
  double *iniRefNorRO,
  double rtx,
  double *rotationAnglesRB,
  double *x1,
  double *x2,
  double thetax)
{
  double t10;
  double t101;
  double t102;
  double t104;
  double t107;
  double t111;
  double t114;
  double t116;
  double t118;
  double t120;
  double t123;
  double t125;
  double t126;
  double t127;
  double t129;
  double t131;
  double t133;
  double t139;
  double t14;
  double t143;
  double t149;
  double t15;
  double t153;
  double t159;
  double t165;
  double t166;
  double t168;
  double t17;
  double t170;
  double t175;
  double t18;
  double t182;
  double t187;
  double t19;
  double t196;
  double t199;
  double t207;
  double t21;
  double t210;
  double t220;
  double t226;
  double t23;
  double t236;
  double t243;
  double t245;
  double t247;
  double t25;
  double t250;
  double t251;
  double t253;
  double t263;
  double t266;
  double t27;
  double t273;
  double t279;
  double t286;
  double t29;
  double t292;
  double t301;
  double t31;
  double t310;
  double t32;
  double t33;
  double t39;
  double t4;
  double t40;
  double t46;
  double t47;
  double t5;
  double t55;
  double t60;
  double t62;
  double t65;
  double t70;
  double t73;
  double t74;
  double t75;
  double t76;
  double t77;
  double t78;
  double t79;
  double t80;
  double t82;
  double t83;
  double t84;
  double t85;
  double t87;
  double t88;
  double t9;
  double t90;
  double t91;
  double t95;
  double t96;
  double t99;
  t4 = x2[0] - 0.1e1 * x1[0];
  t5 = t4 * t4;
  t9 = x2[1] - 0.1e1 * x1[1];
  t10 = t9 * t9;
  t14 = x2[2] - 0.1e1 * x1[2];
  t15 = t14 * t14;
  t17 = sqrt(t5 + t10 + t15);
  t18 = 0.1e1 / t17;
  t19 = t18 * t9;
  t21 = iniRefTanRO[0] * t18;
  t23 = 0.1e1 * t21 * t4;
  t25 = iniRefTanRO[1] * t18;
  t27 = 0.1e1 * t25 * t9;
  t29 = iniRefTanRO[2] * t18;
  t31 = 0.1e1 * t29 * t14;
  t32 = t23 + t27 + t31;
  t33 = iniRefNorRO[2];
  t39 = 0.1e1 * t25 * t14 - 0.1e1 * t29 * t9;
  t40 = iniRefNorRO[1];
  t46 = -0.1e1 * t21 * t14 + 0.1e1 * t29 * t4;
  t47 = iniRefNorRO[0];
  t55 = 0.1e1 * t21 * t9 - 0.1e1 * t25 * t4;
  t60 = (t33 * t55 + t39 * t47 + t40 * t46) / (0.1e1 + t23 + t27 + t31);
  t62 = t32 * t33 + t39 * t40 - t46 * t47 + t55 * t60;
  t65 = t18 * t14;
  t70 = t32 * t40 - t33 * t39 + t46 * t60 + t47 * t55;
  t73 = 0.1e1 * t19 * t62 - 0.1e1 * t65 * t70;
  t74 = cos(rtx);
  t75 = rotationAnglesRB[2];
  t76 = cos(t75);
  t77 = rotationAnglesRB[1];
  t78 = cos(t77);
  t79 = t76 * t78;
  t80 = iniMatTanRB[0];
  t82 = sin(t77);
  t83 = t76 * t82;
  t84 = rotationAnglesRB[0];
  t85 = sin(t84);
  t87 = sin(t75);
  t88 = cos(t84);
  t90 = t83 * t85 - t87 * t88;
  t91 = iniMatTanRB[1];
  t95 = t83 * t88 + t85 * t87;
  t96 = iniMatTanRB[2];
  t99 = (t79 * t80 + t90 * t91 + t95 * t96) * t18;
  t101 = 0.1e1 * t99 * t4;
  t102 = t87 * t78;
  t104 = t87 * t82;
  t107 = t104 * t85 + t76 * t88;
  t111 = t104 * t88 - t76 * t85;
  t114 = (t102 * t80 + t107 * t91 + t111 * t96) * t18;
  t116 = 0.1e1 * t114 * t9;
  t118 = t78 * t85;
  t120 = t78 * t88;
  t123 = (t118 * t91 + t120 * t96 - t80 * t82) * t18;
  t125 = 0.1e1 * t123 * t14;
  t126 = t101 + t116 + t125;
  t127 = iniMatNorRB[0];
  t129 = iniMatNorRB[1];
  t131 = iniMatNorRB[2];
  t133 = t127 * t79 + t129 * t90 + t131 * t95;
  t139 = -0.1e1 * t99 * t14 + 0.1e1 * t123 * t4;
  t143 = t118 * t129 + t120 * t131 - t127 * t82;
  t149 = 0.1e1 * t99 * t9 - 0.1e1 * t114 * t4;
  t153 = t102 * t127 + t107 * t129 + t111 * t131;
  t159 = 0.1e1 * t114 * t14 - 0.1e1 * t123 * t9;
  t165 = 0.1e1 / (0.1e1 + t101 + t116 + t125);
  t166 = (t133 * t159 + t139 * t153 + t143 * t149) * t165;
  t168 = t126 * t133 + t139 * t143 - t149 * t153 + t159 * t166;
  t170 = sin(rtx);
  t175 = t126 * t143 - t133 * t139 + t149 * t166 + t153 * t159;
  t182 = t126 * t153 + t133 * t149 + t139 * t166 - t143 * t159;
  t187 = t18 * t4;
  t196 = (0.1e1 * t187 * t168 + 0.1e1 * t19 * t182 + 0.1e1 * t65 * t175) * (0.1e1 - t74);
  t199 = t74 * t168 + t170 * (0.1e1 * t19 * t175 - 0.1e1 * t65 * t182) + 0.1e1 * t196 * t187;
  t207 = t32 * t47 + t33 * t46 + t39 * t60 - t40 * t55;
  t210 = -0.1e1 * t187 * t62 + 0.1e1 * t65 * t207;
  t220 = t74 * t182 + t170 * (-0.1e1 * t187 * t175 + 0.1e1 * t65 * t168) + 0.1e1 * t196 * t19;
  t226 = 0.1e1 * t187 * t70 - 0.1e1 * t19 * t207;
  t236 = t74 * t175 + t170 * (0.1e1 * t187 * t182 - 0.1e1 * t19 * t168) + 0.1e1 * t196 * t65;
  t243 = atan2(t199 * t73 + t210 * t220 + t226 * t236, t199 * t207 + t220 * t70 + t236 * t62);
  t245 = pow(thetax + rtx - t243, 0.2e1);
  t247 = 0.1e1 / L0;
  t250 = t165 * t159;
  t251 = cos(thetax);
  t253 = sin(thetax);
  t263 = (0.1e1 * t187 * t207 + 0.1e1 * t19 * t70 + 0.1e1 * t65 * t62) * (0.1e1 - t251);
  t266 = t251 * t62 + t253 * t226 + 0.1e1 * t263 * t65;
  t273 = t251 * t70 + t253 * t210 + 0.1e1 * t263 * t19;
  t279 = t165 * t139;
  t286 = t251 * t207 + t253 * t73 + 0.1e1 * t263 * t187;
  t292 = t165 * t149;
  t301 = pow(0.2e1 * t250 * (0.1e1 * t19 * t266 - 0.1e1 * t65 * t273) + 0.2e1 * t279 * (-0.1e1 * t187 * t266 + 0.1e1 * t65 * t286) + 0.2e1 * t292 * (0.1e1 * t187 * t273 - 0.1e1 * t19 * t286), 0.2e1);
  t310 = pow(-0.2e1 * t250 * t286 - 0.2e1 * t279 * t273 - 0.2e1 * t292 * t266, 0.2e1);
  return(0.5000000000e0 * tK * t245 * t247 + (bKh * t301 + bKw * t310) * t247 / 0.2e1);
}
